import logotekenap.*;

public class SterFractal extends TekenApplet
{	
	private InvoerVariabele aantalNivInv;
	private double z,factor;
	private int maxNiv;
	
	public void initialiseer()
	{	aantalNivInv = new InvoerVariabele("aantal niveau's",0,13,2);
		maakZichtbaar(aantalNivInv);
		z = 50;
		maxNiv = 2;
		factor = 1/(Math.sqrt(2+Math.sqrt(2)));
	}
	public void tekenprogramma()
	{	penUit();stap(0,-70);penAan();
		ster(z,"oranje");
		for(int i=0 ; i<8 ; i++)
		{	rechts(112.5);
			sterFractal(maxNiv,factor*z,true,"oranje");
			links(112.5);
			penUit();sterStap(z);penAan();
		}
	}
	void ster(double z, String kl)
	{	vulAan(kl);
		for(int i=0 ; i<8 ; i++)
		{	sterStap(z);
		}
		vulUit();
	}
	void sterFractal(int niv ,double z,boolean vol, String kl)
	{	if(niv==0)return;
		ster(z,kl);
		if(niv-1>0)
		{	penUit();sterStap(z);sterStap(z);penAan();
			rechts(112.5);
			if(vol)sterFractal(niv-1,z*factor,true,kl);
			else sterFractal(niv-1,z*factor,false,kl);
			links(112.5);
			penUit();sterStap(z);penAan();
			rechts(112.5);
			if(vol)sterFractal(niv-1,z*factor,true,kl);
			links(112.5);
			penUit();sterStap(z);penAan();
			rechts(112.5);
			if(vol)sterFractal(niv-1,z*factor,false,kl);
			links(112.5);
			for(int i=0 ; i<4 ; i++)
			{	penUit();sterStap(z);penAan();
			}
		}
	}
	void sterStap(double z)
	{	vooruit(z);
		rechts(110);
		vooruit(z);
		links(155);
	}
	public void invoerVarActie(InvoerVariabele iv)
	{	maxNiv = aantalNivInv.geefWaarde();
		tekenOpnieuw();
	}
}
			